﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ReArrayDemo2
{
    class MyControl<T>
    {
        T t;
        public MyControl(T t)
        {
            this.t = t;
        }
        public T getT()
        {
            return t;
        }

    }


    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        LinkLabel[] _lb = new LinkLabel[0];
        LinkLabel[] _lb2 = new LinkLabel[0];

        private void Form1_Load(object sender, EventArgs e)
        {
        }

        void ReArray()
        {
            int i = _lb.Length + 1;
            Array.Resize<LinkLabel>(ref _lb, i);
            _lb[i-1] = new LinkLabel();
        }

        void ReArray2(Control []ob)
        {
            int i = ob.Length + 1;
            ob = (LinkLabel[])ResizeArray(ob, i);
            ob[i - 1] = new LinkLabel();
        }

        static void RearrLinklbl(ref LinkLabel[] ob)
        {
            int i = ob.Length + 1;
            Array.Resize(ref ob, i);
            ob[i - 1] = new LinkLabel();
        }

        // Reallocates an array with a new size, and copies the contents
        // of the old array to the new array.
        // Arguments:
        //   oldArray  the old array, to be reallocated.
        //   newSize   the new array size.
        // Returns     A new array with the same contents.
        public static System.Array ResizeArray(System.Array oldArray, int newSize)
        {
            int oldSize = oldArray.Length;
            System.Type elementType = oldArray.GetType().GetElementType();
            System.Array newArray = System.Array.CreateInstance(elementType, newSize);
            int preserveLength = System.Math.Min(oldSize, newSize);
            if (preserveLength > 0)
                System.Array.Copy(oldArray, newArray, preserveLength);
            return newArray;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                for (int i = 0; i < 100; i++)
                {
                    // 방법2
                    ReArray();
                    _lb[i].Text = i.ToString();

                    // 방법2
                    RearrLinklbl(ref _lb2);
                    _lb2[i].Text = i.ToString();
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < 100; i++)
                textBox1.Text += "\r\n" + _lb2[i].Text;
        }
    }
}
